; Base	b812
include \masm32\include\masm32rt.inc

;.NOLIST
;.NOCREF
;.486
;.model flat,stdcall
;option casemap:none

WinMain	proto :DWORD,:DWORD,:DWORD,:DWORD

;include		windows.inc
;include		user32.inc
;include		kernel32.inc
;include		gdi32.inc
;include		comdlg32.inc
;includelib	user32.lib
;includelib	kernel32.lib
;includelib	gdi32.lib
;includelib	comdlg32.lib	;paths set in c:\aw.bat

lfstyle	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
chstyle	EQU	CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
;.RADIX	16	; access violation for radix 16

.DATA

LFwc	LABEL	DWORD		;LFile Window Class structure
	DD	SIZEOF WNDCLASSEX	; 0 wc.cbSize
	DD	lfstyle			; 4 wc.style
	DD	WProc			; 8 wc.lpfnWndProc
	DD	0,0			;0C wc.cbClsExtra, wc.cbWndExtra
hinst	DD	?			;14 wc.hinst
hicon	DD	?			;18 LoadIcon,0,IDI_APPLICATION
hcurs	DD	?			;1C LoadCursor,NULL,IDC_ARROW
hbkbr	DD	?			;20 CreateSolidBrush,0FF0000h
wcmen	DD	0			;24 wc.lpszMenuName
	DD	ClassName		;28 wc.lpszClassName
hiconsm	DD	?			;2C wc.hIconSm
					;30	end LFwc
LFwcc	LABEL	DWORD		;LFile Window Child Class structure
	DD	SIZEOF WNDCLASSEX	; 0
	DD	chstyle			; 4
	DD	CWProc			; 8
	DD	0,0			; C
chinst	DD	?			;14 Dwords at 14,18,1C and 2C are copied
	DD	?			;18   from LFwc in newwin
	DD	?			;1C 
	DD	?			;20 From CreateSolidBrush,0EEEE00
	DD	0			;24
	DD	ChldClass		;28 ClassName
	DD	?			;2C

ClassName	DB	"LFclass",0
AppName		DB	"testp b811",0

ChldClass	DB	"LFChildclass",0
ChildW		DB	"lfwChild",0

font1	LABEL	DWORD	;typedef struct tagLOGFONT {
	DD	?	; 0  LONG lfHeight
	DD	?	; 4  LONG lfWidth
escp	DD	0	; 8  LONG lfEscapement;
orie	DD	0	; C  LONG lfOrientation;
wght	DD	240	;10  LONG lfWeight;
ital	DB	0	;14  BYTE lfItalic;
undl	DB	0	;15  BYTE lfUnderline;
strk	DB	0	;16  BYTE lfStrikeOut;
chst	DB	OEM_CHARSET	;17  BYTE lfCharSet	-1 = OEM_CHARSET
opre	DB	0	;18  BYTE lfOutPrecision	\
cpre	DB	0	;19  BYTE lfClipPrecision	 0 = default
qual	DB	0	;1A  BYTE lfQuality		/
pfam	DB	FIXED_PITCH or FF_MODERN	;1B  BYTE lfPitchAndFamily
face	DB	"OEM_FIXED_FONT",0	;1C
			;2B  font1 ends
	ALIGN

msdat	LABEL	BYTE		;Main Screen DATA

	DB	"0          Testing Child Window Creation, etc",0
	DB	"1 23456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef 123456789abcdef",0
	DB	"2",0
	DB	"3 sszh = screen size vertical = 50",0
	DB	"4 sszv = screen size vertical = 20",0
	DB	"5",0
	DB	"6    Commands:",0
	DB	"7       escape - exit",0
	DB	"8       w - open child Window",0
	DB	"9       back - beep",0
	DB	"a",0
	DB	"b",0
	DB	"c",0
	DB	"d",0
	DB	"e",0
	DB	"f",0
	DB	"10",0
	DB	"11",0
	DB	"12",0
	DB	"13",0
	DB	"14",0
	DB	"15",0
	DB	"16",0
	DB	"17",0
	DB	"18",0
	DB	"19",0
	DB	"1a",0
	DB	"1b",0
	DB	"1c",0
	DB	"1d",0
	DB	"1e",0
	DB	"1f",0
	DB	"20",0
	DB	"21",0
	DB	"22",0
	DB	"23",0
	DB	"24 Bottom Line",0
	ALIGN

sszh	DD	50	;Screen SiZe Horizontal - columns
fsszv	DD	25	;Full Screen SiZe Vertical - lines
msszv	DD	21	;Main Screen SiZe Vertical - lines
scrbf	DB	50*25 DUP (" ")	;screen buffer, 25 rows, 50 columns
flgs	DD	0	;System internal - bits 12 - 14 used here
; s,10	reserved	test BYTE PTR [flgs+2],0
; s,11	reserved			2
; s,12	Child Class Registered		4
; s,13	Child Exists			8
; s,14	Child Active			10

mbcap	DB	"Error",0		;Message Box Caption
.DATA?

hdc	DD	?	;Handles to Device Context
ghwnd	DD	?	;	to main window
cfown	DD	?	;	to window owner
hfont1	DD	?	;	to font1

rect	LABEL	DWORD	;No separate rect for child for now.
r_lft	DD	?	;00 When we have chars in the child
r_top	DD	?	;04 we'll use the same char cell sizes.
r_rgt	DD	?	;08
r_bot	DD	?	;0C

cszh	DD	?	;Char cell SiZe Horizontal
cszv	DD	?	;Char cell SiZe Vertical

cmdl	DB	40 DUP (?)	;not used - 

ps	LABEL	DWORD	;PAINTSTRUCT
	DD	10h DUP (?)

erbf	DB	200h DUP (?)

;LOCAL	msg:MSG
;LOCAL	hwnd:HWND
msg	MSG <?>
hwnd	HWND ?

.CODE

;;;	Initialize, Winmain

;;-	Init

;   start:	Initialize LFwc		(5 handles)

start:
	invoke	CreateSolidBrush,0FF0000h
	mov	[hbkbr], eax

	invoke	LoadIcon,0,IDI_APPLICATION
	mov	[hicon], eax
	mov	[hiconsm], eax

	invoke	LoadCursor,0,IDC_ARROW
	mov	[hcurs], eax

	invoke	GetModuleHandle, 0
	mov	[hinst], eax

;		invoke WinMain,hinst,hprev,cmdl,SW_SHOWDEFAULT

;	int 3
	invoke	WinMain,hinst,0,cmdl,SW_SHOWDEFAULT
;		invoke ExitProcess,eax

	invoke	ExitProcess,eax

;;-	winmain

WinMain	proc hInst,hPrevinst,CmdLine,CmdShow

;LOCAL	msg:MSG
;LOCAL	hwnd:HWND

	invoke	RegisterClassEx, OFFSET LFwc
	pushad
	MsgBox 0, str$(eax), "RegisterClassEx", MB_OK
	popad
	mov	edx, CW_USEDEFAULT
;int 3
	invoke	CreateWindowEx,WS_EX_APPWINDOW,ADDR ClassName,ADDR AppName,\
	WS_OVERLAPPEDWINDOW,edx,edx,edx,edx,0,  0,hInst,0
;			    \x, y, szh, szv/^par^men/	^lparam
	pushad
	MsgBox 0, str$(eax), "CW", MB_OK
	popad
	or eax, eax
	  jz	germs2

	mov	[hwnd], eax

	invoke	ShowWindow,hwnd,SW_SHOWMAXIMIZED

	call	gsva				;Get Screen VAriables

	invoke UpdateWindow, hwnd

	.while TRUE
		invoke GetMessage, ADDR msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	ret

;   gsva:	!GetClientRect		eax  [r_bot]		div BY [fsszv]

gsva:
	invoke	GetClientRect,hwnd,ADDR rect	;Get Screen VAriables

	mov	eax, [r_bot]
	div	BYTE PTR [fsszv]

	movzx	eax, al
	mov	[cszv], eax		;Character Cell SiZe Vertical

	mov	eax, [r_rgt]
	div	BYTE PTR [sszh]

	movzx	eax, al
	mov	[cszh], eax		;Character Cell SiZe Horizontal
	retn


;;	GERMS2		Get ERror MeSsage 2	use msgbx

;   germs2:	invoke getlasterror	!FormatMessage,sys,,eax,0,erbf,bfsz,0

germs2:
	invoke	GetLastError

	xor	edx, edx
	mov	esi, OFFSET erbf
	invoke	FormatMessage,1000,edx,eax,edx, esi,100,edx

	invoke	MessageBox,0, esi,0, MB_CANCELTRYCONTINUE

	retn

;i:\sandbox\testnote.lfw has notes

;		!MessageBox,hwnd,ADDR erbf,ADDR mbcap,MB_CANCELTRYCONTINUE

	invoke	MessageBox, hwnd, ADDR erbf, ADDR mbcap, MB_CANCELTRYCONTINUE
;			    ^own  ^txt	     ^cap	  ^type
;		int 3			retn

	int	3

	retn

WinMain endp

;;;	WProc - Main Windows Procedure
;;		- Init, Messages, exit

WProc proc wp_hWnd,uMsg,wParam,lParam
	pushad

;	mov	eax, [wp_hWnd]
;	mov	[hwnd], eax

	mov	eax, [uMsg]		;message handling
	mov	edx, [wParam]
	mov	ecx, [lParam]

	cmp	eax, WM_DESTROY
	  jnz	@F
WPdes:	invoke	PostQuitMessage,NULL
	  jmp	WPend
@@:	cmp	eax, WM_PAINT
	  jnz	@F
	call	dspl
	  jmp	WPend
@@:	cmp	eax, WM_KEYDOWN
	  jnz	@F
	  jmp	key
	  jmp	WPend
@@:	popad
	invoke	DefWindowProc,wp_hWnd,uMsg,wParam,lParam
	ret				;one of two rets from wproc

WPend:	popad
	xor	eax,eax
	ret

;;		- Key

key:
	cmp	dl, 1Bh		;escape
	  jz	WPdes

	cmp	dl, 57		;w
	  jz	newwin
	cmp	dl, 8		;back
	  jnz	WPend

	invoke	Beep, 0B00h,0B0h
	  jmp	WPend

;;		- DSPL  Main Display

;   dspl:	!BeginPaint		[hdc]  eax		edi  font1

dspl:	invoke	BeginPaint,wp_hWnd,ADDR ps		;fills (ps) w/ defaults

	mov	[hdc], eax

	mov	edi, OFFSET font1
;		eax,  [cszv]		[edi]  eax		eax  [cszh]-1

	mov	eax, [cszv]

	mov	[edi], eax		;height in font1

	mov	eax, [cszh]
	dec	eax
;		[edi+4]  eax		!CreateFontInd		[hfont1]  eax

	mov	[edi+4], eax		;width in font1

	invoke	CreateFontIndirect,edi

	mov	[hfont1], eax
;		!SelectObject		call dspl_0

	invoke	SelectObject,hdc,eax

	call	dspl_0
;		!EndPaint		retn

	invoke	EndPaint,wp_hWnd,ADDR ps

	retn

;   dspl_0:	!set colors white/blue	call wscbf		esi  scrbf

dspl_0:
	invoke	SetTextColor,hdc,0FFFFFFh

	invoke	SetBkColor,hdc,0FF0000h		;set screen colors white on blue

	call	wscbf			;write data to scrbf
					;this 2-step process is looking ahead
					;  to when there are more data sources
	mov	esi, OFFSET scrbf
;		ecx,[cntr]  [msszv]	edi,ebx  0		call _cx
;		ecx  [msszv]		edi,ebx  0		call _cx

	mov	ecx, [msszv]
;	mov	BY [cntr], cl

	xor	edi, edi		;vertical position, logical units
	mov	ebx, edi		;horizontal position
;	add	edi, [cszv]		;??? If edi starts at 0, as it should,
;	dec	edi			;??? all's fine except titlebar over-
			;??? writes line 0 - of course, it's WinDbg,'s t-bar!
	call	dspl_cx
;		set colors white/black	[cntr]  4		fallthru to _cx
;		set colors white/black	ecx  4		fallthru to _cx

	invoke	SetTextColor,hdc,0
	invoke	SetBkColor,hdc,0FFFFFFh		;

;	mov	BY [cntr], 4
	mov	ecx, 4

;   dspl_cx:	push ecx		!to			add edi, [cszv]

dspl_cx:
	push	ecx

	invoke	TextOut,hdc,ebx,edi,esi,[sszh]

	add	edi, [cszv]		;each line is cszv in height
;		add esi, [sszh]		pop ecx
	add	esi, [sszh]

	pop	ecx

cmp ecx,1
ja @F
nop
@@:
;		loop _cx		retn

	loop	dspl_cx

	retn
;;		-- WSCRBF	Write SCreen BuFfer

;   wscbr:	esi  msdat		edi  scrbf		edx  [msszv]

wscbf:	mov	esi, OFFSET msdat
	mov	edi, OFFSET scrbf
	mov	edx, [msszv]
;   _lp0:	ecx  [sszh]		call _lp		dec edx

wscbf_lp0:
	mov	ecx, [sszh]
	call	wscbf_lp
	dec	edx
;		jnz _lp0		retn

	  jnz	wscbf_lp0

	retn
;   _lp:	lodsb			al=0 => _lpe		stosb

wscbf_lp:
	lodsb
	or	al, al
	  jz	wscbf_lpe
	stosb
;		loop _lp		inc esi

	loop	wscbf_lp

	inc	esi		;skip the "0" if there are sszh chars
;   _lpe:	add edi, ecx		retn

wscbf_lpe:
	add	edi, ecx
	retn


;;	NEWWIN	NEW child WINdow

newwin:	test	BYTE PTR [flgs+2],4		; s,12 Is class registered?
	  jnz	newwin_0

	mov	esi, OFFSET hinst	;LFwc+14
	mov	edi, OFFSET chinst
	mov	ecx, 3
	rep	movsd			;hinst,hicon,hcurs
	mov	eax, [esi+0Ch]		;hiconsm
	mov	[edi+0Ch], eax		;- copy main window's values

	invoke	CreateSolidBrush,0EEEE00h
	mov	[edi], eax		;edi left at LFwcc +14+0C = 20

	invoke	RegisterClassEx, OFFSET LFwcc
	or	eax, eax
	  jnz	@F
	invoke	Beep,0B00h,0B0h
	retn

@@:	or	BYTE PTR [flgs+2],4		;s,12 - child class registered

newwin_0:
	mov	edx, CW_USEDEFAULT
	xor	eax,eax
	mov	esi, OFFSET ChldClass
	mov	edi, OFFSET ChildW

	invoke	CreateWindowEx,eax,esi,edi,chstyle,edx,edx,edx,edx,\
		wp_hWnd,0,hinst,eax
	or	eax, eax
	  jnz	@F
	invoke	Beep,0B00h,0B0h

@@:	invoke	ShowWindow,eax,SW_SHOWNORMAL

	  jmp	WPend

	WProc endp

;;;	CWProc

CWProc proc cwphw,msg2,wparam,lparam

	pushad
	or	BYTE PTR [flgs+2],18	; s,13 & s,14 child exists and active

	mov	edx, [wparam]
	mov	ecx, [lparam]
	mov	eax, [msg2]

	cmp	eax, WM_DESTROY
	  jnz	@F
CWPdes:	invoke	DestroyWindow,cwphw
	and	BYTE PTR [flgs+2],not 18	; s,13 & 14
	  jmp	CWPend
@@:	cmp	eax, WM_PAINT
	  jnz	@F
;	call	cdspl
	  jmp	CWPend
@@:	cmp	eax, WM_KEYDOWN
	  jnz	@F
	  jmp	ckey
@@:	invoke	DefWindowProc,cwphw,msg2,wparam,lparam
	popad
	ret				;one of two rets from CWProc

CWPend:	popad
	xor	eax,eax
	ret				;the other

;;	CKEY	Child KEY functions

ckey:
	cmp	dl, 1Bh		;escape
	  jz	CWPdes
	cmp	dl, 8		;back
	  jz	ckey_par
	cmp	dl, 23		;keypad 1
	  jz	ckey_test
	invoke	Beep,0B00h,0B0h
	  jmp	CWPend

ckey_test:
	invoke	Beep,0B00h,0B0h
	invoke	Beep,0B00h,0B0h
	  jmp	CWPend

ckey_par:
	invoke	SetFocus,cwphw
	or	eax, eax
	  jnz	@F
	invoke	Beep,0B00h,0B0h
@@:	and	BYTE PTR [flgs+2],not 10	;s,14  child not active
	  jmp	CWPend

	CWProc endp

	END	start


; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
OPT_Tmp2Asm 1
